/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAnimationEffectReadOnly.h"

#include "JSAnimationEffectTimingReadOnly.h"
#include "JSComputedTimingProperties.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsAnimationEffectReadOnlyPrototypeFunctionGetComputedTiming(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsAnimationEffectReadOnlyConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAnimationEffectReadOnlyConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsAnimationEffectReadOnlyTiming(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAnimationEffectReadOnlyPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAnimationEffectReadOnlyPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAnimationEffectReadOnlyPrototype* ptr = new (NotNull, JSC::allocateCell<JSAnimationEffectReadOnlyPrototype>(vm.heap)) JSAnimationEffectReadOnlyPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAnimationEffectReadOnlyPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSAnimationEffectReadOnlyConstructor = JSDOMConstructorNotConstructable<JSAnimationEffectReadOnly>;

template<> JSValue JSAnimationEffectReadOnlyConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSAnimationEffectReadOnlyConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSAnimationEffectReadOnly::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("AnimationEffectReadOnly"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAnimationEffectReadOnlyConstructor::s_info = { "AnimationEffectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectReadOnlyConstructor) };

/* Hash table for prototype */

static const HashTableValue JSAnimationEffectReadOnlyPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationEffectReadOnlyConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAnimationEffectReadOnlyConstructor) } },
    { "timing", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationEffectReadOnlyTiming), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "getComputedTiming", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsAnimationEffectReadOnlyPrototypeFunctionGetComputedTiming), (intptr_t) (0) } },
};

const ClassInfo JSAnimationEffectReadOnlyPrototype::s_info = { "AnimationEffectReadOnlyPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectReadOnlyPrototype) };

void JSAnimationEffectReadOnlyPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAnimationEffectReadOnly::info(), JSAnimationEffectReadOnlyPrototypeTableValues, *this);
}

const ClassInfo JSAnimationEffectReadOnly::s_info = { "AnimationEffectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectReadOnly) };

JSAnimationEffectReadOnly::JSAnimationEffectReadOnly(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AnimationEffectReadOnly>&& impl)
    : JSDOMWrapper<AnimationEffectReadOnly>(structure, globalObject, WTFMove(impl))
{
}

void JSAnimationEffectReadOnly::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAnimationEffectReadOnly::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAnimationEffectReadOnlyPrototype::create(vm, &globalObject, JSAnimationEffectReadOnlyPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSAnimationEffectReadOnly::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAnimationEffectReadOnly>(vm, globalObject);
}

JSValue JSAnimationEffectReadOnly::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAnimationEffectReadOnlyConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSAnimationEffectReadOnly::destroy(JSC::JSCell* cell)
{
    JSAnimationEffectReadOnly* thisObject = static_cast<JSAnimationEffectReadOnly*>(cell);
    thisObject->JSAnimationEffectReadOnly::~JSAnimationEffectReadOnly();
}

template<> inline JSAnimationEffectReadOnly* IDLAttribute<JSAnimationEffectReadOnly>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSAnimationEffectReadOnly*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSAnimationEffectReadOnly* IDLOperation<JSAnimationEffectReadOnly>::cast(ExecState& state)
{
    return jsDynamicCast<JSAnimationEffectReadOnly*>(state.vm(), state.thisValue());
}

EncodedJSValue jsAnimationEffectReadOnlyConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAnimationEffectReadOnlyPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSAnimationEffectReadOnly::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSAnimationEffectReadOnlyConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAnimationEffectReadOnlyPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsAnimationEffectReadOnlyTimingGetter(ExecState& state, JSAnimationEffectReadOnly& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<AnimationEffectTimingReadOnly>>(state, *thisObject.globalObject(), throwScope, impl.timing());
    return result;
}

EncodedJSValue jsAnimationEffectReadOnlyTiming(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSAnimationEffectReadOnly>::get<jsAnimationEffectReadOnlyTimingGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "timing");
}

static inline JSC::EncodedJSValue jsAnimationEffectReadOnlyPrototypeFunctionGetComputedTimingBody(JSC::ExecState* state, typename IDLOperation<JSAnimationEffectReadOnly>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLDictionary<ComputedTimingProperties>>(*state, *castedThis->globalObject(), impl.getComputedTiming()));
}

EncodedJSValue JSC_HOST_CALL jsAnimationEffectReadOnlyPrototypeFunctionGetComputedTiming(ExecState* state)
{
    return IDLOperation<JSAnimationEffectReadOnly>::call<jsAnimationEffectReadOnlyPrototypeFunctionGetComputedTimingBody>(*state, "getComputedTiming");
}

bool JSAnimationEffectReadOnlyOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSAnimationEffectReadOnlyOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsAnimationEffectReadOnly = static_cast<JSAnimationEffectReadOnly*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsAnimationEffectReadOnly->wrapped(), jsAnimationEffectReadOnly);
}

AnimationEffectReadOnly* JSAnimationEffectReadOnly::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSAnimationEffectReadOnly*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
