/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMediaCapabilitiesInfo.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsMediaCapabilitiesInfoConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSMediaCapabilitiesInfoConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsMediaCapabilitiesInfoSupported(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaCapabilitiesInfoSmooth(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaCapabilitiesInfoPowerEfficient(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSMediaCapabilitiesInfoPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSMediaCapabilitiesInfoPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaCapabilitiesInfoPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaCapabilitiesInfoPrototype>(vm.heap)) JSMediaCapabilitiesInfoPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaCapabilitiesInfoPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSMediaCapabilitiesInfoConstructor = JSDOMConstructorNotConstructable<JSMediaCapabilitiesInfo>;

template<> JSValue JSMediaCapabilitiesInfoConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSMediaCapabilitiesInfoConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSMediaCapabilitiesInfo::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("MediaCapabilitiesInfo"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSMediaCapabilitiesInfoConstructor::s_info = { "MediaCapabilitiesInfo", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaCapabilitiesInfoConstructor) };

/* Hash table for prototype */

static const HashTableValue JSMediaCapabilitiesInfoPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaCapabilitiesInfoConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaCapabilitiesInfoConstructor) } },
    { "supported", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaCapabilitiesInfoSupported), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "smooth", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaCapabilitiesInfoSmooth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "powerEfficient", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaCapabilitiesInfoPowerEfficient), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSMediaCapabilitiesInfoPrototype::s_info = { "MediaCapabilitiesInfoPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaCapabilitiesInfoPrototype) };

void JSMediaCapabilitiesInfoPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMediaCapabilitiesInfo::info(), JSMediaCapabilitiesInfoPrototypeTableValues, *this);
}

const ClassInfo JSMediaCapabilitiesInfo::s_info = { "MediaCapabilitiesInfo", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaCapabilitiesInfo) };

JSMediaCapabilitiesInfo::JSMediaCapabilitiesInfo(Structure* structure, JSDOMGlobalObject& globalObject, Ref<MediaCapabilitiesInfo>&& impl)
    : JSDOMWrapper<MediaCapabilitiesInfo>(structure, globalObject, WTFMove(impl))
{
}

void JSMediaCapabilitiesInfo::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSMediaCapabilitiesInfo::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSMediaCapabilitiesInfoPrototype::create(vm, &globalObject, JSMediaCapabilitiesInfoPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSMediaCapabilitiesInfo::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSMediaCapabilitiesInfo>(vm, globalObject);
}

JSValue JSMediaCapabilitiesInfo::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSMediaCapabilitiesInfoConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSMediaCapabilitiesInfo::destroy(JSC::JSCell* cell)
{
    JSMediaCapabilitiesInfo* thisObject = static_cast<JSMediaCapabilitiesInfo*>(cell);
    thisObject->JSMediaCapabilitiesInfo::~JSMediaCapabilitiesInfo();
}

template<> inline JSMediaCapabilitiesInfo* IDLAttribute<JSMediaCapabilitiesInfo>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSMediaCapabilitiesInfo*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsMediaCapabilitiesInfoConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSMediaCapabilitiesInfoPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSMediaCapabilitiesInfo::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSMediaCapabilitiesInfoConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSMediaCapabilitiesInfoPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsMediaCapabilitiesInfoSupportedGetter(ExecState& state, JSMediaCapabilitiesInfo& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.supported());
    return result;
}

EncodedJSValue jsMediaCapabilitiesInfoSupported(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSMediaCapabilitiesInfo>::get<jsMediaCapabilitiesInfoSupportedGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "supported");
}

static inline JSValue jsMediaCapabilitiesInfoSmoothGetter(ExecState& state, JSMediaCapabilitiesInfo& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.smooth());
    return result;
}

EncodedJSValue jsMediaCapabilitiesInfoSmooth(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSMediaCapabilitiesInfo>::get<jsMediaCapabilitiesInfoSmoothGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "smooth");
}

static inline JSValue jsMediaCapabilitiesInfoPowerEfficientGetter(ExecState& state, JSMediaCapabilitiesInfo& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.powerEfficient());
    return result;
}

EncodedJSValue jsMediaCapabilitiesInfoPowerEfficient(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSMediaCapabilitiesInfo>::get<jsMediaCapabilitiesInfoPowerEfficientGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "powerEfficient");
}

bool JSMediaCapabilitiesInfoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSMediaCapabilitiesInfoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsMediaCapabilitiesInfo = static_cast<JSMediaCapabilitiesInfo*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaCapabilitiesInfo->wrapped(), jsMediaCapabilitiesInfo);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<MediaCapabilitiesInfo>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to MediaCapabilitiesInfo.
    static_assert(!std::is_polymorphic<MediaCapabilitiesInfo>::value, "MediaCapabilitiesInfo is polymorphic but the IDL claims it is not");
    return createWrapper<MediaCapabilitiesInfo>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, MediaCapabilitiesInfo& impl)
{
    return wrap(state, globalObject, impl);
}

MediaCapabilitiesInfo* JSMediaCapabilitiesInfo::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMediaCapabilitiesInfo*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
