/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAccessibilityObjectModelEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value);
}

bool WebPreferences::accessibilityObjectModelEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey());
}

void WebPreferences::setAsyncFrameScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value);
}

bool WebPreferences::asyncFrameScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey());
}

void WebPreferences::setEncryptedMediaAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::encryptedMediaAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::encryptedMediaAPIEnabledKey(), value);
}

bool WebPreferences::encryptedMediaAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::encryptedMediaAPIEnabledKey());
}

void WebPreferences::setFetchAPIKeepAliveEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value);
}

bool WebPreferences::fetchAPIKeepAliveEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey());
}

void WebPreferences::setFullScreenEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fullScreenEnabledKey(), value);
}

bool WebPreferences::fullScreenEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey());
}

void WebPreferences::setImageBitmapOffscreenCanvasEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value);
}

bool WebPreferences::imageBitmapOffscreenCanvasEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey());
}

void WebPreferences::setMDNSICECandidatesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mDNSICECandidatesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mDNSICECandidatesEnabledKey(), value);
}

bool WebPreferences::mDNSICECandidatesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mDNSICECandidatesEnabledKey());
}

void WebPreferences::setProcessSwapOnNavigationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::processSwapOnNavigationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::processSwapOnNavigationEnabledKey(), value);
}

bool WebPreferences::processSwapOnNavigationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::processSwapOnNavigationEnabledKey());
}

void WebPreferences::setResourceLoadStatisticsDebugMode(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey(), value);
}

bool WebPreferences::resourceLoadStatisticsDebugMode() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey());
}

void WebPreferences::setServerTimingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serverTimingEnabledKey(), value);
}

bool WebPreferences::serverTimingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey());
}

void WebPreferences::setServiceWorkersEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serviceWorkersEnabledKey(), value);
}

bool WebPreferences::serviceWorkersEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey());
}

void WebPreferences::setSpringTimingFunctionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value);
}

bool WebPreferences::springTimingFunctionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey());
}

void WebPreferences::setVisualViewportAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value);
}

bool WebPreferences::visualViewportAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey());
}

void WebPreferences::setWebAnimationsCSSIntegrationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value);
}

bool WebPreferences::webAnimationsCSSIntegrationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey());
}

void WebPreferences::setWebAnimationsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsEnabledKey(), value);
}

bool WebPreferences::webAnimationsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey());
}

void WebPreferences::setWebGL2Enabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGL2EnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGL2EnabledKey(), value);
}

bool WebPreferences::webGL2Enabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGL2EnabledKey());
}

void WebPreferences::setWebGLCompressedTextureASTCSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value);
}

bool WebPreferences::webGLCompressedTextureASTCSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey());
}

void WebPreferences::setWebGPUEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGPUEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGPUEnabledKey(), value);
}

bool WebPreferences::webGPUEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGPUEnabledKey());
}

void WebPreferences::setWebVREnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webVREnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webVREnabledKey(), value);
}

bool WebPreferences::webVREnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webVREnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::experimentalFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::ExperimentalFeature::create("Accessibility Object Model", "AccessibilityObjectModelEnabled", "Accessibility Object Model support", false, false),
        API::ExperimentalFeature::create("Async Frame Scrolling", "AsyncFrameScrollingEnabled", "Perform frame scrolling in a dedicated thread or process", false, false),
#if ENABLE(ENCRYPTED_MEDIA)
        API::ExperimentalFeature::create("Modern Encrypted Media API", "EncryptedMediaAPIEnabled", "Modern Encrypted Media API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#endif
        API::ExperimentalFeature::create("Fetch API Request KeepAlive", "FetchAPIKeepAliveEnabled", "Enable Fetch API Request KeepAlive", false, false),
#if ENABLE(FULLSCREEN_API)
        API::ExperimentalFeature::create("Fullscreen API", "FullScreenEnabled", "Fullscreen API", false, EXPERIMENTAL_FULLSCREEN_API_HIDDEN),
#endif
        API::ExperimentalFeature::create("ImageBitmap and OffscreenCanvas", "ImageBitmapOffscreenCanvasEnabled", "Support for the ImageBitmap and OffscreenCanvas APIs", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("Enable MDNS ICE candidates", "MDNSICECandidatesEnabled", "Enable MDNS ICE candidates", false, false),
#endif
        API::ExperimentalFeature::create("Swap Processes on Navigation", "ProcessSwapOnNavigationEnabled", "Swap WebContent processes on cross-origin navigations", false, false),
        API::ExperimentalFeature::create("ITP Debug Mode", "ResourceLoadStatisticsDebugMode", "Intelligent Tracking Prevention Debug Mode", false, false),
        API::ExperimentalFeature::create("Server Timing", "ServerTimingEnabled", "Enable Server Timing API", false, false),
#if ENABLE(SERVICE_WORKER)
        API::ExperimentalFeature::create("ServiceWorkers", "ServiceWorkersEnabled", "Enable ServiceWorkers", DEFAULT_SERVICE_WORKERS_ENABLED, false),
#endif
        API::ExperimentalFeature::create("CSS Spring Animations", "SpringTimingFunctionEnabled", "CSS Spring Animation prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("VisualViewportAPI", "VisualViewportAPIEnabled", "Enable Visual Viewport API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Web Animations and CSS Integration", "WebAnimationsCSSIntegrationEnabled", "Expose CSS Animations and CSS Transitions through getAnimations()", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Web Animations", "WebAnimationsEnabled", "Web Animations prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(WEBGL2)
        API::ExperimentalFeature::create("WebGL 2.0", "WebGL2Enabled", "WebGL 2 prototype", false, false),
#endif
        API::ExperimentalFeature::create("ASTC Texture Support", "WebGLCompressedTextureASTCSupportEnabled", "Support for ASTC compressed texture formats in WebGL", false, false),
#if ENABLE(WEBGPU)
        API::ExperimentalFeature::create("WebGPU", "WebGPUEnabled", "WebGPU prototype", false, false),
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
        API::ExperimentalFeature::create("WebVR", "WebVREnabled", "WebVR Module support", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#endif
    });

    return features;
}

bool WebPreferences::isEnabledForFeature(const API::ExperimentalFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::accessibilityObjectModelEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::asyncFrameScrollingEnabled },
#if ENABLE(ENCRYPTED_MEDIA)
        { "EncryptedMediaAPIEnabled", &WebPreferences::encryptedMediaAPIEnabled },
#endif
        { "FetchAPIKeepAliveEnabled", &WebPreferences::fetchAPIKeepAliveEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::fullScreenEnabled },
#endif
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::imageBitmapOffscreenCanvasEnabled },
#if ENABLE(WEB_RTC)
        { "MDNSICECandidatesEnabled", &WebPreferences::mDNSICECandidatesEnabled },
#endif
        { "ProcessSwapOnNavigationEnabled", &WebPreferences::processSwapOnNavigationEnabled },
        { "ResourceLoadStatisticsDebugMode", &WebPreferences::resourceLoadStatisticsDebugMode },
        { "ServerTimingEnabled", &WebPreferences::serverTimingEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::serviceWorkersEnabled },
#endif
        { "SpringTimingFunctionEnabled", &WebPreferences::springTimingFunctionEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::visualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::webAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::webAnimationsEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::webGL2Enabled },
#endif
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::webGLCompressedTextureASTCSupportEnabled },
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::webGPUEnabled },
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::webVREnabled },
#endif
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setEnabledForFeature(bool value, const API::ExperimentalFeature& feature)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::setAccessibilityObjectModelEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::setAsyncFrameScrollingEnabled },
#if ENABLE(ENCRYPTED_MEDIA)
        { "EncryptedMediaAPIEnabled", &WebPreferences::setEncryptedMediaAPIEnabled },
#endif
        { "FetchAPIKeepAliveEnabled", &WebPreferences::setFetchAPIKeepAliveEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::setFullScreenEnabled },
#endif
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::setImageBitmapOffscreenCanvasEnabled },
#if ENABLE(WEB_RTC)
        { "MDNSICECandidatesEnabled", &WebPreferences::setMDNSICECandidatesEnabled },
#endif
        { "ProcessSwapOnNavigationEnabled", &WebPreferences::setProcessSwapOnNavigationEnabled },
        { "ResourceLoadStatisticsDebugMode", &WebPreferences::setResourceLoadStatisticsDebugMode },
        { "ServerTimingEnabled", &WebPreferences::setServerTimingEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::setServiceWorkersEnabled },
#endif
        { "SpringTimingFunctionEnabled", &WebPreferences::setSpringTimingFunctionEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::setVisualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::setWebAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::setWebAnimationsEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::setWebGL2Enabled },
#endif
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::setWebGLCompressedTextureASTCSupportEnabled },
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::setWebGPUEnabled },
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::setWebVREnabled },
#endif
    };

    const String& key = feature.key();
    
    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::enableAllExperimentalFeatures()
{
    setAccessibilityObjectModelEnabled(true);
    setAsyncFrameScrollingEnabled(true);
#if ENABLE(ENCRYPTED_MEDIA)
    setEncryptedMediaAPIEnabled(true);
#endif
    setFetchAPIKeepAliveEnabled(true);
#if ENABLE(FULLSCREEN_API)
    setFullScreenEnabled(true);
#endif
    setImageBitmapOffscreenCanvasEnabled(true);
#if ENABLE(WEB_RTC)
    setMDNSICECandidatesEnabled(true);
#endif
    setProcessSwapOnNavigationEnabled(true);
    setResourceLoadStatisticsDebugMode(true);
    setServerTimingEnabled(true);
#if ENABLE(SERVICE_WORKER)
    setServiceWorkersEnabled(true);
#endif
    setSpringTimingFunctionEnabled(true);
    setVisualViewportAPIEnabled(true);
    setWebAnimationsCSSIntegrationEnabled(true);
    setWebAnimationsEnabled(true);
#if ENABLE(WEBGL2)
    setWebGL2Enabled(true);
#endif
    setWebGLCompressedTextureASTCSupportEnabled(true);
#if ENABLE(WEBGPU)
    setWebGPUEnabled(true);
#endif
#if PLATFORM(GTK) || PLATFORM(WPE)
    setWebVREnabled(true);
#endif
}

}
